#include <bits/stdc++.h>
#ifndef dbg 
#define dbg(...)
#endif

using namespace std;

int main() {
  ios::sync_with_stdio(0);
  cin.tie(0);

  int p; cin >> p;
  int n; cin >> n;
  vector<int64_t> v(n);
  auto Value = [&](int pos) -> int64_t {
    assert(0 < pos && pos < n - 1);
    return v[pos - 1] + v[pos + 1] - 2 * v[pos];
  };

  set<pair<int64_t, int>> s;
  for (int i = 0; i < n; ++i) {
    cin >> v[i];
  }
  for (int i = 1; i < n - 1; ++i) {
    int64_t val = Value(i);
    if (val < 0) s.emplace(-val, i);
  }

  int64_t operations = 0;
  while (!s.empty()) {
    int64_t val; int pos;
    tie(val, pos) = *s.begin();
    s.erase(s.begin());

    if (pos - 1 > 0) {
      int64_t old = Value(pos - 1);
      s.erase({-old, pos - 1});
    }
    if (pos + 1 < n - 1) {
      int64_t old = Value(pos + 1);
      s.erase({-old, pos + 1});
    }

    assert(-val == Value(pos));
    v[pos] -= val;
    if (pos - 1 > 0) {
      int64_t new_val = Value(pos - 1);
      if (new_val < 0) s.emplace(-new_val, pos - 1);
    }
    if (pos + 1 < n - 1) {
      int64_t new_val = Value(pos + 1);
      if (new_val < 0) s.emplace(-new_val, pos + 1);
    }
    ++operations;
  }
  
  int64_t ans = accumulate(v.begin(), v.end(), 0LL);
  cout << (p == 1 ? ans : operations) << endl;
}
