#include <bits/stdc++.h>

using namespace std;

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);

  int p; cin >> p;
  int n; cin >> n;
  vector<int64_t> v(n);
  for (int i = 0; i < n; ++i) {
    cin >> v[i];
  }

  auto GetValue = [&](int pos) -> int64_t {
    assert(0 < pos && pos < n - 1);
    return v[pos - 1] + v[pos + 1] - v[pos];
  };

  bool done = false;
  int64_t count_operations = 0;
  while (!done) {
    done = true;
    for (int i = 1; i < n - 1; ++i) {
      if (GetValue(i) < v[i]) {
        v[i] = GetValue(i);
        ++count_operations;
        done = false;
      }
    }
  }

  int64_t sum = 0;
  for (int i = 0; i < n; ++i) {
    sum += v[i];
  }
  cout << (p == 1 ? sum : count_operations) << endl;
}
